/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.yy"
 /* -*- C++ -*- */
/***************************************************************************
                      parser.ypp  -  syntaxical analyzer
                             -------------------
    begin                : Thu May 25 2003
    copyright            : (C) 2003 CEA and Universite Paris Sud
    author               : Gilles Mouchard
    email                : mouchard@lri.fr
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <parser.hh>
#include <vect.hh>
#include <isa.hh>
#include <sourcecode.hh>
#include <action.hh>
#include <comment.hh>
#include <operation.hh>
#include <subdecoder.hh>
#include <variable.hh>
#include <bitfield.hh>
#include <specialization.hh>
#include <scanner.hh>
#include <conststr.hh>
#include <cstdarg>
#include <cstdio>
#include <cstring>
#include <vector>
#include <cstdlib>
  
int yylex();
int yyerror( char const* _err );

static
void
create_action( Operation_t* _operation, ActionProto_t const* _actionproto, SourceCode_t* _actioncode ) {
  Action_t const* prev_action = _operation->action( _actionproto );

  if( prev_action ) {
    Scanner::fileloc.err( "error: action `%s.%s' redefined",
                          _operation->m_symbol.str(), _actionproto->m_symbol.str() );
    
    prev_action->m_fileloc.err( "action `%s.%s' previously defined here",
                                _operation->m_symbol.str(), _actionproto->m_symbol.str() );
    exit( -1 );
  }
  
  _operation->add( new Action_t( _actionproto, _actioncode, Scanner::comments, Scanner::fileloc ) );
}

static void
extend_oplist( Vect_t<Operation_t>* _oplist, Operation_t* _op ) {
  // Suppress duplicated entries
  for( Vect_t<Operation_t>::const_iterator node = _oplist->begin(); node < _oplist->end(); ++ node ) {
    if( (*node)->m_symbol != _op->m_symbol ) continue;
    Scanner::fileloc.err( "warning: duplicated operation `%s' in list", _op->m_symbol.str() );
    return;
  }
  
  _oplist->append( _op );
}

static bool
extend_oplist( Vect_t<Operation_t>* _oplist, ConstStr_t _symbol ) {
  /* Symbol points to either an operation or a group */
  Operation_t* operation = Scanner::isa().operation( _symbol );
  if( operation ) {
    /* Symbol points to an operation */
    extend_oplist( _oplist, operation );
  } else {
    Group_t* group = Scanner::isa().group( _symbol );
    if( group ) {
      /* Symbol points to a group */
      for( Vect_t<Operation_t>::iterator gop = group->m_operations.begin(); gop < group->m_operations.end(); ++ gop )
        extend_oplist( _oplist, *gop );
    } else {
      Scanner::fileloc.err( "error: undefined operation `%s'", _symbol.str() );
      return false;
    }
  }
  return true;
}



/* Line 189 of yacc.c  */
#line 165 "parser.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_ENDL = 258,
     TOK_TAB = 259,
     TOK_QUAD_DOT = 260,
     TOK_ACTION = 261,
     TOK_CONST = 262,
     TOK_CONSTRUCTOR = 263,
     TOK_DECL = 264,
     TOK_DECODER = 265,
     TOK_DESTRUCTOR = 266,
     TOK_GROUP = 267,
     TOK_IMPL = 268,
     TOK_INCLUDE = 269,
     TOK_INHERITANCE = 270,
     TOK_NAMESPACE = 271,
     TOK_OP = 272,
     TOK_REWIND = 273,
     TOK_SET = 274,
     TOK_SEXT = 275,
     TOK_SHL = 276,
     TOK_SHR = 277,
     TOK_SPECIALIZE = 278,
     TOK_STATIC = 279,
     TOK_SUBDECODER = 280,
     TOK_TEMPLATE = 281,
     TOK_VAR = 282,
     TOK_SOURCE_CODE = 283,
     TOK_IDENT = 284,
     TOK_INTEGER = 285,
     TOK_STRING = 286
   };
#endif
/* Tokens.  */
#define TOK_ENDL 258
#define TOK_TAB 259
#define TOK_QUAD_DOT 260
#define TOK_ACTION 261
#define TOK_CONST 262
#define TOK_CONSTRUCTOR 263
#define TOK_DECL 264
#define TOK_DECODER 265
#define TOK_DESTRUCTOR 266
#define TOK_GROUP 267
#define TOK_IMPL 268
#define TOK_INCLUDE 269
#define TOK_INHERITANCE 270
#define TOK_NAMESPACE 271
#define TOK_OP 272
#define TOK_REWIND 273
#define TOK_SET 274
#define TOK_SEXT 275
#define TOK_SHL 276
#define TOK_SHR 277
#define TOK_SPECIALIZE 278
#define TOK_STATIC 279
#define TOK_SUBDECODER 280
#define TOK_TEMPLATE 281
#define TOK_VAR 282
#define TOK_SOURCE_CODE 283
#define TOK_IDENT 284
#define TOK_INTEGER 285
#define TOK_STRING 286




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 268 "parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   149

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  90
/* YYNRULES -- Number of states.  */
#define YYNSTATES  180

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       9,    10,     3,     2,     5,     7,     8,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
      13,     6,    14,    44,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    11,     2,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    11,    15,    20,    21,
      25,    33,    37,    41,    45,    50,    52,    55,    58,    61,
      64,    67,    70,    73,    76,    79,    82,    85,    87,    89,
      91,    94,    96,    98,   100,   103,   106,   109,   112,   114,
     118,   119,   122,   123,   128,   130,   134,   139,   147,   152,
     158,   161,   165,   166,   171,   176,   177,   179,   180,   184,
     187,   193,   197,   202,   205,   207,   211,   212,   215,   220,
     230,   231,   233,   234,   236,   239,   240,   242,   246,   247,
     249,   251,   253,   259,   265,   267,   271,   275,   278,   284,
     286
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      46,     0,    -1,    47,    -1,    -1,    47,    56,    -1,    41,
      -1,    48,    17,    41,    -1,    37,    48,    41,    50,    -1,
      -1,    13,    40,    14,    -1,    37,    48,    11,    42,     4,
      42,    12,    -1,    31,    41,    41,    -1,    31,    41,    40,
      -1,    31,    41,    42,    -1,    38,    13,    79,    14,    -1,
      15,    -1,    52,    15,    -1,    53,    15,    -1,    54,    15,
      -1,    51,    15,    -1,    49,    15,    -1,    63,    15,    -1,
      75,    15,    -1,    81,    15,    -1,    60,    15,    -1,    58,
      15,    -1,    59,    15,    -1,    85,    -1,    71,    -1,    70,
      -1,    69,    15,    -1,    86,    -1,    57,    -1,    55,    -1,
      82,    15,    -1,    28,    48,    -1,    21,    40,    -1,    25,
      40,    -1,    40,    -1,     9,    64,    10,    -1,    -1,    40,
       4,    -1,    -1,    62,    29,    41,    61,    -1,    65,    -1,
      64,     4,    65,    -1,    42,    11,    42,    12,    -1,    66,
      67,    68,    41,    11,    42,    12,    -1,    44,    11,    42,
      12,    -1,     3,    41,    11,    41,    12,    -1,    14,    13,
      -1,    14,    30,    13,    -1,    -1,    34,    13,    42,    14,
      -1,    33,    13,    42,    14,    -1,    -1,    32,    -1,    -1,
      13,    42,    14,    -1,    13,    14,    -1,    27,    40,    40,
       6,    40,    -1,    27,    40,    40,    -1,    41,     8,    39,
      72,    -1,    39,    72,    -1,    74,    -1,    72,     5,    74,
      -1,    -1,     6,    40,    -1,    41,     4,    40,    73,    -1,
      80,    18,    76,    41,     9,    79,    10,    77,    40,    -1,
      -1,    40,    -1,    -1,    19,    -1,    40,    40,    -1,    -1,
      78,    -1,    79,     5,    78,    -1,    -1,    20,    -1,    23,
      -1,    36,    -1,    41,     8,    41,     6,    40,    -1,    35,
      41,     9,    83,    10,    -1,    84,    -1,    83,     5,    84,
      -1,    41,     6,    42,    -1,    26,    43,    -1,    24,    41,
       9,    87,    10,    -1,    41,    -1,    87,     5,    41,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   182,   182,   184,   184,   188,   192,   199,   228,   231,
     238,   265,   278,   290,   302,   309,   310,   311,   312,   313,
     314,   315,   319,   323,   326,   330,   334,   338,   339,   344,
     345,   349,   353,   356,   365,   371,   383,   389,   395,   401,
     406,   411,   416,   421,   450,   454,   460,   464,   468,   472,
     485,   489,   496,   499,   503,   510,   513,   520,   523,   527,
     534,   538,   544,   570,   576,   580,   587,   590,   596,   606,
     667,   670,   677,   680,   686,   695,   698,   702,   709,   712,
     716,   720,   726,   762,   778,   782,   788,   794,   801,   828,
     835
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'*'", "':'", "','", "'='", "'-'", "'.'",
  "'('", "')'", "'['", "']'", "'<'", "'>'", "TOK_ENDL", "TOK_TAB",
  "TOK_QUAD_DOT", "TOK_ACTION", "TOK_CONST", "TOK_CONSTRUCTOR", "TOK_DECL",
  "TOK_DECODER", "TOK_DESTRUCTOR", "TOK_GROUP", "TOK_IMPL", "TOK_INCLUDE",
  "TOK_INHERITANCE", "TOK_NAMESPACE", "TOK_OP", "TOK_REWIND", "TOK_SET",
  "TOK_SEXT", "TOK_SHL", "TOK_SHR", "TOK_SPECIALIZE", "TOK_STATIC",
  "TOK_SUBDECODER", "TOK_TEMPLATE", "TOK_VAR", "TOK_SOURCE_CODE",
  "TOK_IDENT", "TOK_INTEGER", "TOK_STRING", "'?'", "$accept", "input",
  "declaration_list", "namespace_list", "subdecoder_instance",
  "template_scheme", "subdecoder_class", "global_ident_parameter",
  "global_sourcecode_parameter", "global_uinteger_parameter",
  "template_declaration", "declaration", "namespace_declaration",
  "sourcecode_decl_declaration", "sourcecode_impl_declaration",
  "sourcecode_declaration", "bitfield_list_decl", "op_condition",
  "operation_declaration", "bitfield_list", "bitfield", "shift", "sext",
  "size_modifier", "global_inheritance_declaration",
  "op_var_list_declaration", "global_var_list_declaration", "var_list",
  "var_init", "var", "action_proto_declaration", "returns", "constness",
  "param", "param_list", "action_proto_type", "action_declaration",
  "specialization", "constraint_list", "constraint", "include",
  "group_declaration", "operation_list", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,    42,    58,    44,    61,    45,    46,    40,
      41,    91,    93,    60,    62,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    45,    46,    47,    47,    48,    48,    49,    50,    50,
      51,    52,    53,    54,    55,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    57,    58,    59,    60,    61,
      61,    62,    62,    63,    64,    64,    65,    65,    65,    65,
      65,    65,    66,    66,    66,    67,    67,    68,    68,    68,
      69,    69,    70,    71,    72,    72,    73,    73,    74,    75,
      76,    76,    77,    77,    78,    79,    79,    79,    80,    80,
      80,    80,    81,    82,    83,    83,    84,    85,    86,    87,
      87
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     3,     4,     0,     3,
       7,     3,     3,     3,     4,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     1,
       2,     1,     1,     1,     2,     2,     2,     2,     1,     3,
       0,     2,     0,     4,     1,     3,     4,     7,     4,     5,
       2,     3,     0,     4,     4,     0,     1,     0,     3,     2,
       5,     3,     4,     2,     1,     3,     0,     2,     4,     9,
       0,     1,     0,     1,     2,     0,     1,     3,     0,     1,
       1,     1,     5,     5,     1,     3,     3,     2,     5,     1,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,    15,    79,     0,    80,     0,     0,
       0,     0,     0,     0,     0,    81,     0,     0,     0,    38,
       0,     0,     0,     0,     0,     0,    33,     4,    32,     0,
       0,     0,     0,     0,     0,    29,    28,     0,     0,     0,
       0,    27,    31,    36,     0,    37,    87,     0,     5,    35,
       0,     0,     0,    75,     0,    63,    64,    41,     0,    20,
      19,    16,    17,    18,    25,    26,    24,     0,    21,    30,
      22,    70,    23,    34,     0,    61,     0,    12,    11,    13,
       0,     0,     8,     0,    76,     0,     0,     0,     0,     0,
      40,    71,     0,    89,     0,     0,     6,     0,     0,    84,
       0,     0,     7,    74,     0,    14,    66,    65,    62,     0,
      52,    43,     0,     0,    88,    60,     0,     0,    83,     0,
       0,    77,     0,    68,    82,     0,     0,     0,     0,     0,
       0,     0,    44,    55,    75,    90,    86,    85,     0,     9,
      67,     0,    50,     0,     0,     0,     0,     0,    52,    39,
      56,    57,     0,    10,     0,    51,     0,     0,     0,     0,
      45,     0,     0,    72,     0,    54,    53,    46,    48,    59,
       0,     0,    73,     0,    49,    58,     0,    69,     0,    47
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    49,    21,   102,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   111,    32,    33,   131,
     132,   133,   151,   162,    34,    35,    36,    55,   123,    56,
      37,    92,   173,    84,    85,    38,    39,    40,    98,    99,
      41,    42,    94
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -51
static const yytype_int8 yypact[] =
{
     -51,     7,    22,   -51,   -51,   -51,   -25,   -51,   -18,   -15,
     -16,   -14,    -8,    -7,    -6,   -51,    -8,    15,    -5,    34,
      36,    37,    39,    40,    41,    49,   -51,   -51,   -51,    50,
      51,    52,    42,    53,    54,   -51,   -51,    55,    56,    57,
      58,   -51,   -51,   -51,    66,   -51,   -51,    38,   -51,    59,
     -23,    68,    -9,    43,    75,    76,   -51,   -51,   -17,   -51,
     -51,   -51,   -51,   -51,   -51,   -51,   -51,    44,   -51,   -51,
     -51,    46,   -51,   -51,    47,    74,    48,   -51,   -51,   -51,
      60,    45,    69,    62,   -51,    -1,    63,    -5,    -5,    78,
      81,   -51,    64,   -51,     0,    67,   -51,    85,     4,   -51,
      88,    70,   -51,   -51,    43,   -51,    87,   -51,    76,    71,
      -3,   -51,    86,    65,   -51,   -51,    72,    60,   -51,    73,
      80,   -51,    77,   -51,   -51,    79,   -10,    83,    84,    89,
      93,     2,   -51,    90,    43,   -51,   -51,   -51,    96,   -51,
     -51,    98,   -51,    99,    82,    91,    92,    94,    -3,   -51,
     -51,   100,    11,   -51,    97,   -51,   102,   104,   107,   109,
     -51,   -13,   101,   106,   111,   -51,   -51,   -51,   -51,   -51,
     112,   116,   -51,    95,   -51,   -51,   103,   -51,   117,   -51
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -51,   -51,   -51,   114,   -51,   -51,   -51,   -51,   -51,   -51,
     -51,   -51,   -51,   -51,   -51,   -51,   -51,   -51,   -51,   -51,
     -50,   -51,   -51,   -51,   -51,   -51,   -51,    61,   -51,    12,
     -51,   -51,   -51,    24,    -2,   -51,   -51,   -51,   -51,    14,
     -51,   -51,   -51
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -79
static const yytype_int16 yytable[] =
{
     125,   169,    81,   142,   104,   113,   148,     3,    76,   117,
     114,   126,   149,   105,   118,    43,   104,    77,    78,    79,
     143,   163,    88,    44,    89,    45,    47,    46,    53,   170,
     127,   128,    82,    48,    50,    51,    54,     4,    57,   129,
     -78,   130,     5,     6,    58,     7,     8,     9,    10,    11,
      12,   -42,    59,    13,    60,    61,    62,    14,    15,    16,
      17,    18,    19,    20,    63,    64,    65,    66,    68,    69,
      70,    67,    72,    73,    71,    74,    76,    80,    75,    86,
      95,    87,   101,    83,   109,    90,    91,   100,    93,    96,
     110,   116,   119,   122,   139,   134,   144,   145,   160,   107,
     146,    97,   103,   106,   147,   112,   135,   115,   153,   154,
     120,   124,   155,   161,   136,   138,   165,   140,   166,   167,
     141,   168,   150,   174,   156,   172,   175,   176,   121,   179,
      52,   137,   152,   157,   158,   177,   159,     0,   164,     0,
       0,     0,   171,     0,     0,   178,     0,     0,     0,   108
};

static const yytype_int16 yycheck[] =
{
       3,    14,    11,    13,     5,     5,     4,     0,    17,     5,
      10,    14,    10,    14,    10,    40,     5,    40,    41,    42,
      30,    10,    39,    41,    41,    40,    40,    43,    13,    42,
      33,    34,    41,    41,    41,    41,    41,    15,     4,    42,
      18,    44,    20,    21,     8,    23,    24,    25,    26,    27,
      28,    29,    15,    31,    15,    15,    15,    35,    36,    37,
      38,    39,    40,    41,    15,    15,    15,    15,    15,    15,
      15,    29,    15,    15,    18,     9,    17,     9,    40,     4,
       6,     5,    13,    40,     6,    41,    40,    42,    41,    41,
       9,     6,     4,     6,    14,     9,    13,    13,   148,    87,
      11,    41,    40,    40,    11,    41,    41,    40,    12,    11,
      40,    40,    13,    13,    42,    42,    14,    40,    14,    12,
      41,    12,    32,    12,    42,    19,    14,    11,   104,    12,
      16,   117,   134,    42,    42,    40,    42,    -1,    41,    -1,
      -1,    -1,    41,    -1,    -1,    42,    -1,    -1,    -1,    88
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    46,    47,     0,    15,    20,    21,    23,    24,    25,
      26,    27,    28,    31,    35,    36,    37,    38,    39,    40,
      41,    49,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    62,    63,    69,    70,    71,    75,    80,    81,
      82,    85,    86,    40,    41,    40,    43,    40,    41,    48,
      41,    41,    48,    13,    41,    72,    74,     4,     8,    15,
      15,    15,    15,    15,    15,    15,    15,    29,    15,    15,
      15,    18,    15,    15,     9,    40,    17,    40,    41,    42,
       9,    11,    41,    40,    78,    79,     4,     5,    39,    41,
      41,    40,    76,    41,    87,     6,    41,    41,    83,    84,
      42,    13,    50,    40,     5,    14,    40,    74,    72,     6,
       9,    61,    41,     5,    10,    40,     6,     5,    10,     4,
      40,    78,     6,    73,    40,     3,    14,    33,    34,    42,
      44,    64,    65,    66,     9,    41,    42,    84,    42,    14,
      40,    41,    13,    30,    13,    13,    11,    11,     4,    10,
      32,    67,    79,    12,    11,    13,    42,    42,    42,    42,
      65,    13,    68,    10,    41,    14,    14,    12,    12,    14,
      42,    41,    19,    77,    12,    14,    11,    40,    42,    12
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 182 "parser.yy"
    { }
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 184 "parser.yy"
    {}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 189 "parser.yy"
    {
  (yyval.string_list) = new StringVect_t( (yyvsp[(1) - (1)].persistent_string) );
}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 193 "parser.yy"
    {
  (yyval.string_list) = (yyvsp[(1) - (3)].string_list)->append( (yyvsp[(3) - (3)].persistent_string) );
}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 200 "parser.yy"
    {
  StringVect_t* nmspc_in = (yyvsp[(2) - (4)].string_list);
  ConstStr_t symbol = ConstStr_t( (yyvsp[(3) - (4)].persistent_string), Scanner::symbols );
  SourceCode_t* template_scheme = (yyvsp[(4) - (4)].sourcecode);
  
  std::vector<ConstStr_t> nmspc( nmspc_in->size(), ConstStr_t() );
  for( intptr_t idx = nmspc_in->size(); (--idx) >= 0; )
    nmspc[idx] = ConstStr_t( (*nmspc_in)[idx], Scanner::symbols );
  delete nmspc_in;
  
  SDClass_t const* sdclass = Scanner::isa().sdclass( nmspc );
  if( not sdclass ) {
    Scanner::fileloc.err( "error: subdecoder has not been declared" );
    YYABORT;
  }
  
  SDInstance_t const* sdinstance = Scanner::isa().sdinstance( symbol );
  if( sdinstance ) {
    Scanner::fileloc.err( "error: subdecoder instance `%s' redefined", symbol.str() );
    sdinstance->m_fileloc.err( "subdecoder instance `%s' previously defined here", symbol.str() );
    YYABORT;
  }
  
  Scanner::isa().m_sdinstances.append( new SDInstance_t( symbol, template_scheme, sdclass, Scanner::fileloc ) );
}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 228 "parser.yy"
    {
  (yyval.sourcecode) = 0;
}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 232 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(2) - (3)].sourcecode);
}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 239 "parser.yy"
    {
  StringVect_t* nmspc_in = (yyvsp[(2) - (7)].string_list);
  unsigned int minsize = (yyvsp[(4) - (7)].uinteger), maxsize = (yyvsp[(6) - (7)].uinteger);

  if( minsize > maxsize ) {
    Scanner::fileloc.err( "error: subdecoder operation range is reversed" );
    YYABORT;
  }
  
  std::vector<ConstStr_t> nmspc( nmspc_in->size(), ConstStr_t() );
  for( intptr_t idx = nmspc_in->size(); (--idx) >= 0; )
    nmspc[idx] = ConstStr_t( (*nmspc_in)[idx], Scanner::symbols );
  delete nmspc_in;
  
  SDClass_t const* sdclass = Scanner::isa().sdclass( nmspc );
  
  if( sdclass ) {
    Scanner::fileloc.err( "error: subdecoder class redeclared." );
    sdclass->m_fileloc.err( "subdecoder class previously declared here." );
    YYABORT;
  }
  
  Scanner::isa().m_sdclasses.append( new SDClass_t( nmspc, minsize, maxsize, Scanner::fileloc ) );
}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 266 "parser.yy"
    {
  ConstStr_t key( (yyvsp[(2) - (3)].persistent_string), Scanner::symbols );
  ConstStr_t val( (yyvsp[(3) - (3)].persistent_string), Scanner::symbols );
  
  try {
    Scanner::isa().setparam( key, val );
  } catch( Isa::UnknownIdent ui ) {
    Scanner::fileloc.err( "error: unknown or illegal ident `%s'.", ui.m_ident.str() );
    YYABORT;
  }
}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 279 "parser.yy"
    {
  ConstStr_t key( (yyvsp[(2) - (3)].persistent_string), Scanner::symbols );
  SourceCode_t* val = (yyvsp[(3) - (3)].sourcecode);
  try {
    Scanner::isa().setparam( key, val );
  } catch( Isa::UnknownIdent ui ) {
    Scanner::fileloc.err( "error: unknown or illegal ident `%s'.", ui.m_ident.str() );
    YYABORT;
  }
}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 291 "parser.yy"
    {
  ConstStr_t key( (yyvsp[(2) - (3)].persistent_string), Scanner::symbols );
  unsigned int val = (yyvsp[(3) - (3)].uinteger);
  try {
    Scanner::isa().setparam( key, val );
  } catch( Isa::UnknownIdent ui ) {
    Scanner::fileloc.err( "error: unknown or illegal ident `%s'.", ui.m_ident.str() );
    YYABORT;
  }
}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 303 "parser.yy"
    {
  (yyval.param_list) = (yyvsp[(3) - (4)].param_list);
}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 309 "parser.yy"
    {}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 316 "parser.yy"
    {
  Scanner::isa().m_operations.append( (yyvsp[(1) - (2)].operation) );
}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 320 "parser.yy"
    {
  Scanner::isa().m_actionprotos.push_back( (yyvsp[(1) - (2)].actionproto) );
}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 324 "parser.yy"
    {
}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 327 "parser.yy"
    {
  Scanner::isa().m_decl_srccodes.push_back( (yyvsp[(1) - (2)].sourcecode) );
}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 331 "parser.yy"
    {
  Scanner::isa().m_decl_srccodes.push_back( (yyvsp[(1) - (2)].sourcecode) );
}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 335 "parser.yy"
    {
  Scanner::isa().m_impl_srccodes.push_back( (yyvsp[(1) - (2)].sourcecode) );
}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 338 "parser.yy"
    {}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 340 "parser.yy"
    {
  Scanner::isa().m_vars.append( *(yyvsp[(1) - (1)].variable_list) );
  delete (yyvsp[(1) - (1)].variable_list);
}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 344 "parser.yy"
    {}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 346 "parser.yy"
    {
  Scanner::isa().m_inheritances.push_back( (yyvsp[(1) - (2)].inheritance) );
}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 350 "parser.yy"
    {
  Scanner::isa().m_groups.push_back( (yyvsp[(1) - (1)].group) );
}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 354 "parser.yy"
    {
}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 357 "parser.yy"
    {
  if( not Scanner::isa().m_tparams.empty() ) {
    Scanner::fileloc.err( "error: template parameters defined more than once" );
    YYABORT;
  }
  Scanner::isa().m_tparams = *(yyvsp[(1) - (1)].param_list);
  delete (yyvsp[(1) - (1)].param_list);
}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 366 "parser.yy"
    {
  Scanner::isa().m_specializations.push_back( (yyvsp[(1) - (2)].specialization) );
}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 372 "parser.yy"
    {
  StringVect_t* nmspc = (yyvsp[(2) - (2)].string_list);
  
  for( StringVect_t::const_iterator ident = nmspc->begin(); ident != nmspc->end(); ++ident ) {
    Scanner::isa().m_namespace.push_back( ConstStr_t( *ident, Scanner::symbols ) );
  }
  
  delete nmspc;
}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 384 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(2) - (2)].sourcecode);
}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 390 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(2) - (2)].sourcecode);
}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 396 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(1) - (1)].sourcecode);
}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 402 "parser.yy"
    {
  (yyval.bitfield_list) = (yyvsp[(2) - (3)].bitfield_list);
}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 406 "parser.yy"
    {
  (yyval.bitfield_list) = 0;
}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 412 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(1) - (2)].sourcecode);
}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 416 "parser.yy"
    {
  (yyval.sourcecode) = 0;
}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 422 "parser.yy"
    {
  SourceCode_t*       op_cond = (yyvsp[(1) - (4)].sourcecode);
  ConstStr_t          symbol = ConstStr_t( (yyvsp[(3) - (4)].persistent_string), Scanner::symbols );
  Vect_t<BitField_t>* bitfields = (yyvsp[(4) - (4)].bitfield_list);
  
  {
    Operation_t const* prev_op = Scanner::isa().operation( symbol );
    if( prev_op ) {
      Scanner::fileloc.err( "error: operation `%s' redefined", symbol.str() );
      prev_op->m_fileloc.err( "operation `%s' previously defined here", symbol.str() );
      YYABORT;
    }
    
    Group_t const* prev_grp = Scanner::isa().group( symbol );
    if( prev_grp ) {
      Scanner::fileloc.err( "error: operation `%s' redefined", symbol.str() );
      prev_grp->m_fileloc.err( "group `%s' previously defined here", symbol.str() );
    }
  }

  Operation_t* operation = new Operation_t( symbol, *bitfields, Scanner::comments, op_cond, Scanner::fileloc );
  delete bitfields;
  Scanner::comments.clear();

  (yyval.operation) = operation;
}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 451 "parser.yy"
    {
  (yyval.bitfield_list) = new Vect_t<BitField_t>( (yyvsp[(1) - (1)].bitfield) );
}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 455 "parser.yy"
    {
  (yyval.bitfield_list) = (yyvsp[(1) - (3)].bitfield_list)->append( (yyvsp[(3) - (3)].bitfield) );
}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 461 "parser.yy"
    {
  (yyval.bitfield) = new OpcodeBitField_t( (yyvsp[(3) - (4)].uinteger), (yyvsp[(1) - (4)].uinteger) );
}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 465 "parser.yy"
    {
  (yyval.bitfield) = new OperandBitField_t( (yyvsp[(6) - (7)].uinteger), ConstStr_t( (yyvsp[(4) - (7)].persistent_string), Scanner::symbols ), (yyvsp[(1) - (7)].sinteger), (yyvsp[(3) - (7)].uinteger), (yyvsp[(2) - (7)].boolean) );
}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 469 "parser.yy"
    {
  (yyval.bitfield) = new UnusedBitField_t( (yyvsp[(3) - (4)].uinteger) );
}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 473 "parser.yy"
    {
  ConstStr_t symbol = ConstStr_t( (yyvsp[(2) - (5)].persistent_string), Scanner::symbols );
  ConstStr_t sdinstance_symbol = ConstStr_t( (yyvsp[(4) - (5)].persistent_string), Scanner::symbols );
  SDInstance_t const* sdinstance = Scanner::isa().sdinstance( sdinstance_symbol );
  
  if( not sdinstance ) {
    Scanner::fileloc.err( "error: subdecoder instance `%s' not declared", sdinstance_symbol.str() );
    YYABORT;
  }
  
  (yyval.bitfield) = new SubOpBitField_t( symbol, sdinstance );
}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 486 "parser.yy"
    {
  (yyval.bitfield) = new SeparatorBitField_t( false );
}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 490 "parser.yy"
    {
  (yyval.bitfield) = new SeparatorBitField_t( true );
}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 496 "parser.yy"
    {
  (yyval.sinteger) = 0;
}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 500 "parser.yy"
    {
  (yyval.sinteger) = (yyvsp[(3) - (4)].uinteger);
}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 504 "parser.yy"
    {
  (yyval.sinteger) = -(yyvsp[(3) - (4)].uinteger);
}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 510 "parser.yy"
    {
  (yyval.boolean) = false;
}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 514 "parser.yy"
    {
  (yyval.boolean) = true;
}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 520 "parser.yy"
    {
  (yyval.uinteger) = 0;
}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 524 "parser.yy"
    {
  (yyval.uinteger) = (yyvsp[(2) - (3)].uinteger);
}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 528 "parser.yy"
    {
  (yyval.uinteger) = 0;
}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 535 "parser.yy"
    {
  (yyval.inheritance) = new Inheritance_t( (yyvsp[(2) - (5)].sourcecode), (yyvsp[(3) - (5)].sourcecode), (yyvsp[(5) - (5)].sourcecode) );
}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 539 "parser.yy"
    {
  (yyval.inheritance) = new Inheritance_t( (yyvsp[(2) - (3)].sourcecode), (yyvsp[(3) - (3)].sourcecode), 0 );
}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 545 "parser.yy"
    {
  ConstStr_t    target_symbol = ConstStr_t( (yyvsp[(1) - (4)].persistent_string), Scanner::symbols );
  Vect_t<Variable_t>* var_list = (yyvsp[(4) - (4)].variable_list);
  
  /* Target symbol points to either an operation or a group */
  Operation_t* operation = Scanner::isa().operation( target_symbol );
  if( operation ) {
    /* Target symbol points to an operation */
    operation->m_variables.append( *var_list );
  } else {
    Group_t* group = Scanner::isa().group( target_symbol );
    if( group ) {
      /* Target symbol points to a group */
      for( Vect_t<Operation_t>::iterator gop = group->m_operations.begin(); gop < group->m_operations.end(); ++ gop )
        (**gop).m_variables.append( *var_list );
    } else {
      /* Target symbol doesn't point to anything */
      Scanner::fileloc.err( "error: undefined operation or group `%s'", target_symbol.str() );
      YYABORT;
    }
  }
  delete var_list;
}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 571 "parser.yy"
    {
  (yyval.variable_list) = (yyvsp[(2) - (2)].variable_list);
}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 577 "parser.yy"
    {
  (yyval.variable_list) = new Vect_t<Variable_t>( (yyvsp[(1) - (1)].variable) );
}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 581 "parser.yy"
    {
  (yyval.variable_list) = (yyvsp[(1) - (3)].variable_list)->append( (yyvsp[(3) - (3)].variable) );
}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 587 "parser.yy"
    {
  (yyval.sourcecode) = 0;
}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 591 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(2) - (2)].sourcecode);
}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 597 "parser.yy"
    {
  ConstStr_t     symbol = ConstStr_t( (yyvsp[(1) - (4)].persistent_string), Scanner::symbols );
  SourceCode_t*  c_type = (yyvsp[(3) - (4)].sourcecode);
  SourceCode_t*  c_init = (yyvsp[(4) - (4)].sourcecode);
  
  (yyval.variable) = new Variable_t( symbol, c_type, c_init );
}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 607 "parser.yy"
    {
  ActionProto_t::type_t action_proto_type = ActionProto_t::type_t( (yyvsp[(1) - (9)].sinteger) );
  SourceCode_t*         returns = (yyvsp[(3) - (9)].sourcecode);
  ConstStr_t            symbol = ConstStr_t( (yyvsp[(4) - (9)].persistent_string), Scanner::symbols );
  Vect_t<CodePair_t>*   param_list = (yyvsp[(6) - (9)].param_list);
  SourceCode_t*         default_sourcecode = (yyvsp[(9) - (9)].sourcecode);

  { /* action protype name should be unique */
    ActionProto_t const*  prev_proto = Scanner::isa().actionproto( symbol );
    if( prev_proto ) {
      Scanner::fileloc.err( "error: action prototype `%s' redefined", prev_proto->m_symbol.str() );
      prev_proto->m_fileloc.err( "action prototype `%s' previously defined here", prev_proto->m_symbol.str() );
      YYABORT;
    }
  }
    
  if( returns ) {
    switch( action_proto_type ) {
    case ActionProto_t::Constructor:
      Scanner::fileloc.err( "error: constructor action prototype `%s' must not have a return type (%s)",
                symbol.str(), returns->m_content.str() );
      YYABORT;
      break;
    case ActionProto_t::Destructor:
      Scanner::fileloc.err( "error: destructor action prototype `%s' must not have a return type (%s)",
                symbol.str(), returns->m_content.str() );
      YYABORT;
      break;
    default: break;
    }
  }
  
  if( param_list )
  {
    switch( action_proto_type ) {
    case ActionProto_t::Constructor:
      Scanner::fileloc.err( "error: constructor action prototype `%s' must not take any arguments", symbol.str() );
      YYABORT;
      break;
    case ActionProto_t::Static:
      Scanner::fileloc.err( "error: static action prototype `%s' must not take any arguments", symbol.str() );
      YYABORT;
      break;
    case ActionProto_t::Destructor:
      Scanner::fileloc.err( "error: destructor action prototype `%s' must not take any arguments", symbol.str() );
      YYABORT;
      break;
    default: break;
    }
  }
  
  ActionProto_t* actionproto =
    new ActionProto_t( action_proto_type, symbol, returns, *param_list, (yyvsp[(8) - (9)].boolean), default_sourcecode, Scanner::comments, Scanner::fileloc );
  Scanner::comments.clear();
  delete param_list;
  (yyval.actionproto) = actionproto;
}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 667 "parser.yy"
    {
  (yyval.sourcecode) = 0;
}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 671 "parser.yy"
    {
  (yyval.sourcecode) = (yyvsp[(1) - (1)].sourcecode);
}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 677 "parser.yy"
    {
  (yyval.boolean) = false;
}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 681 "parser.yy"
    {
  (yyval.boolean) = true;
}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 687 "parser.yy"
    {
  SourceCode_t *c_type = (yyvsp[(1) - (2)].sourcecode);
  SourceCode_t *c_symbol = (yyvsp[(2) - (2)].sourcecode);
  (yyval.param) = new CodePair_t( c_type, c_symbol );
}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 695 "parser.yy"
    {
  (yyval.param_list) = 0;
}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 699 "parser.yy"
    {
  (yyval.param_list) = new Vect_t<CodePair_t>( (yyvsp[(1) - (1)].param) );
}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 703 "parser.yy"
    {
  (yyval.param_list) = (yyvsp[(1) - (3)].param_list)->append( (yyvsp[(3) - (3)].param) );
}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 709 "parser.yy"
    {
  (yyval.sinteger) = ActionProto_t::Common;
}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 713 "parser.yy"
    {
  (yyval.sinteger) = ActionProto_t::Constructor;
}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 717 "parser.yy"
    {
  (yyval.sinteger) = ActionProto_t::Destructor;
}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 721 "parser.yy"
    {
  (yyval.sinteger) = ActionProto_t::Static;
}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 727 "parser.yy"
    {
  ConstStr_t    target_symbol = ConstStr_t( (yyvsp[(1) - (5)].persistent_string), Scanner::symbols );
  ConstStr_t    action_proto_symbol = ConstStr_t( (yyvsp[(3) - (5)].persistent_string), Scanner::symbols );
  SourceCode_t* actioncode = (yyvsp[(5) - (5)].sourcecode);
  
  /* Actions belongs to an action prototype */
  ActionProto_t const* actionproto = Scanner::isa().actionproto( action_proto_symbol );

  if( not actionproto ) {
    Scanner::fileloc.err( "error: undefined action prototype `%s'", action_proto_symbol.str() );
    YYABORT;
  }
  
  /* Target symbol points to either an operation or a group */
  Operation_t* operation = Scanner::isa().operation( target_symbol );
  if( operation ) {
    /* Target symbol points to an operation */
    create_action( operation, actionproto, actioncode );
  } else {
    Group_t* group = Scanner::isa().group( target_symbol );
    if( group ) {
      /* Target symbol points to a group */
      for( Vect_t<Operation_t>::iterator gop = group->m_operations.begin(); gop < group->m_operations.end(); ++ gop )
        create_action( *gop, actionproto, actioncode );
    } else {
      /* Target symbol doesn't point to anything */
      Scanner::fileloc.err( "error: undefined operation or group `%s'", target_symbol.str() );
      YYABORT;
    }
  }
  
  Scanner::comments.clear();
}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 763 "parser.yy"
    {
  ConstStr_t            symbol = ConstStr_t( (yyvsp[(2) - (5)].persistent_string), Scanner::symbols );
  Vect_t<Constraint_t>* constraint_list = (yyvsp[(4) - (5)].constraint_list);
  Operation_t*          operation = Scanner::isa().operation( symbol );
  if( not operation ) {
    Scanner::fileloc.err( "error: operation `%s' not defined", symbol.str() );
    YYABORT;
  }
  
  (yyval.specialization) = new Specialization_t( operation, *constraint_list );
  delete constraint_list;
}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 779 "parser.yy"
    {
  (yyval.constraint_list) = new Vect_t<Constraint_t>( (yyvsp[(1) - (1)].constraint) );
}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 783 "parser.yy"
    {
  (yyval.constraint_list) = (yyvsp[(1) - (3)].constraint_list)->append( (yyvsp[(3) - (3)].constraint) );
}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 789 "parser.yy"
    {
  (yyval.constraint) = new Constraint_t( ConstStr_t( (yyvsp[(1) - (3)].persistent_string), Scanner::symbols ), (yyvsp[(3) - (3)].uinteger) );
}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 795 "parser.yy"
    {
  if( not Scanner::include( (yyvsp[(2) - (2)].volatile_string) ) )
    YYABORT;
}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 802 "parser.yy"
    {
  ConstStr_t           group_symbol = ConstStr_t( (yyvsp[(2) - (5)].persistent_string), Scanner::symbols );
  Vect_t<Operation_t>* operation_list = (yyvsp[(4) - (5)].operation_list);
  
  { /* Operations and groups name should not conflict */
    Operation_t* prev_op = Scanner::isa().operation( group_symbol );
    if( prev_op ) {
      Scanner::fileloc.err( "error: group name conflicts with operation `%s'", group_symbol.str() );
      prev_op->m_fileloc.err( "operation `%s' previously defined here", group_symbol.str() );
      YYABORT;
    }
    
    Group_t* prev_grp = Scanner::isa().group( group_symbol );
    if( prev_grp ) {
      Scanner::fileloc.err( "error: group `%s' redefined", group_symbol.str() );
      prev_grp->m_fileloc.err( "group `%s' previously defined here", group_symbol.str() );
      YYABORT;
    }
  }
  
  (yyval.group) = new Group_t( group_symbol, *operation_list, Scanner::fileloc );
  delete operation_list;
}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 829 "parser.yy"
    {
  ConstStr_t symbol = ConstStr_t( (yyvsp[(1) - (1)].persistent_string), Scanner::symbols );
  Vect_t<Operation_t>* oplist = new Vect_t<Operation_t>;
  if( not extend_oplist( oplist, symbol ) ) { YYABORT; }
  (yyval.operation_list) = oplist;
}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 836 "parser.yy"
    {
  Vect_t<Operation_t>* oplist = (yyvsp[(1) - (3)].operation_list);
  ConstStr_t symbol = ConstStr_t( (yyvsp[(3) - (3)].persistent_string), Scanner::symbols );
  if( not extend_oplist( oplist, symbol ) ) { YYABORT; }
  (yyval.operation_list) = oplist;
}
    break;



/* Line 1464 of yacc.c  */
#line 2621 "parser.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 844 "parser.yy"


int yyerror( char const* _err ) { Scanner::fileloc.err( "%s! unexpected %s\n", _err, Scanner::tokenname( yychar ).str() ); return 1; }

